<template>
  <el-dialog
    width="30%"
    title="Add New Category"
    :visible="dialogvisible"
    append-to-body
    @close="$emit('update:dialogvisible', false)"
  >
    <el-form
      id="add-form"
      :model="content"
      :rules="rules"
      ref="content"
      label-width="120px"
      class="demo-content"
      v-loading="loading"
    >
      <!-- <el-form-item class="" prop="icon" label="Icon" >
					<el-upload
							:auto-upload="false"
							class="avatar-uploader full-upload"
							action="https://jsonplaceholder.typicode.com/posts/"
							:show-file-list="false"
							:on-change="onChangeIcon"
							drag>
						<div  v-if="imageUrl" class="upload-img-outer" style="margin: auto">
							<img :src="imageUrl" class="avatar">
							<el-button @click="onRemoveImg" class="icon-img-close" icon="el-icon-close" type="info" circle mini plain></el-button>
						</div>
						<i v-else class="el-icon-plus avatar-uploader-icon"></i>
					</el-upload>
					<div  v-if="imageName" style=""></div>
				</el-form-item> -->
      <el-form-item
        label="Name"
        prop="categoryName"
      >
        <el-input v-model.trim="content.categoryName"></el-input>
      </el-form-item>

      <div style="text-align: right; margin-top: 30px;">
        <el-button
          type="primary"
          @click="submitForm('content')"
          :disabled="loading"
          icon="mdi mdi-plus"
        >Add</el-button>
      </div>
    </el-form>
  </el-dialog>
</template>

<script>
import $ from 'jquery'
import { category as categoryAPI, media as mediaAPI } from '~/services/apis/index';
export default {
  name: 'AddCategory',
  props: ['dialogvisible'],

  data () {
    return {
      fileList: [

      ],
      content: {
        categoryName: '',
      },
      rules: {
        categoryName: [
          { required: true, message: 'Please input Category name', trigger: 'blur' },
          { max: 255, message: 'Length must be less than 256', trigger: 'blur' }
        ],
        position: [
          { validator: this.$helper.validateNumber, trigger: 'blur' }
        ]
      },
      loading: false,
      imageUrl: '',
      imageName: "",
      file: null,
    }
  },
  methods: {
    submitForm (formName) {
      if (!this.$refs[formName]) return false;
      this.$refs[formName].validate((valid) => {
        if (valid) {
          this.loading = true;
          this.create();
        } else {
          this.loading = false;
          return false;
        }
      });
    },
    resetForm (formName) {
      if (!this.$refs[formName]) return;
      this.$refs[formName].resetFields();

      this.removeImg();
    },
    onRemoveImg (e) {
      e.preventDefault();
      e.stopPropagation();
      this.removeImg();
    },
    removeImg () {
      this.imageUrl = "";
      this.imageName = "";
      this.file = null;
    },
    // submit () {
    //   this.loading = true;
    //   if (this.file) {
    //     mediaAPI.upload(this.file)
    //       .then((res) => {
    //         this.create(res.data.data.path)

    //       })
    //       .catch((err) => {
    //         this.loading = false;
    //         this.$notify.error({
    //           title: 'Error',
    //           message: 'Icon upload failed'
    //         });
    //         this.$emit('update:dialogvisible', false);
    //       })
    //   } else {
    //     this.create()
    //   }
    // },
    create () {
      categoryAPI.addCategory(this.content)
        .then((res) => {
          this.$parent.getListData();
          this.loading = false;
          this.$notify({
            title: 'Success',
            message: 'Create category successfully!',
            type: 'success'
          });
          this.$emit('update:dialogvisible', false);
        })
        .catch((err) => {
          this.loading = false;
          this.$notify.error({
            title: 'Error',
            message: 'Cannot create category'
          });
          this.$emit('update:dialogvisible', false);
        })
    },
    onChangeIcon (file, fileList) {
      if (!file) return;
      this.imageName = file.name;
      this.imageUrl = URL.createObjectURL(file.raw);
      this.file = file.raw;
    },
    resetDialog () {
      this.resetForm("content");
    }

  },
  mounted () {
    var that = this;
    $('body').on("submit", "#add-form", function (e) {
      event.preventDefault();
      that.submitForm('content');
    });
  },
  watch: {
    dialogvisible: function () {
      this.resetDialog();
    }
  }

}
</script>

<style lang="scss">
@import "../../assets/scss/_variables";
.item-full-width .el-form-item__content {
  margin-left: 0 !important;
}
.el-dialog__body {
  form {
    margin-top: 10px;
  }
}

.upload-img-outer {
  position: relative;
  .icon-img-close {
    position: absolute;
    top: 3px;
    right: 5px;
    padding: 3px;
    &:hover {
    }
  }
}
</style>
